' PCBoard New Caller Skimmer - PDQ Version 1.00
' Copyright February 1991 by Royal G. Olsen.
' Box 747, Sooke, B.C.              642-6367

' A program to skim the names of new callers from
' the New Caller Log and put them in another file.

' There were no knows bugs or problems when this
' program was released.  However, you are advised
' that you use this program at your own risk.

' This source code was included so that anyone with
' the ability can modify it for their own use only.

DEFINT A-Z

'QuickPac Pro Routines
DECLARE FUNCTION Date2Num (S$)  ' Replacement QBasic code is included
DECLARE FUNCTION Exist (S$)
DECLARE FUNCTION Time2Num& (S$) ' Replacement QBasic code is included

'Quick Basic Routines
DECLARE FUNCTION GetTime& (S$)

S$ = COMMAND$
P = INSTR(S$, " ")            ' Position of Parameter Split
GetFile$ = LEFT$(S$, P - 1)   ' Path/FileName of File to Read
PutFile$ = MID$(S$, P + 1)    ' Path/FileName of File to Write To

IF NOT Exist(GetFile$) THEN END  ' Abort if PCBoard New User file not found

IF NOT Exist(PutFile$) THEN      ' If receiving file not found the make one
   OPEN PutFile$ FOR OUTPUT AS 2
   PRINT #2, "01-01-00 (00:00)  Initiate File For * NEW USER *"
   CLOSE 2
END IF

OPEN PutFile$ FOR INPUT AS 2
WHILE NOT EOF(2)
   INPUT #2, NewUser$           ' Get last file in receiving file
WEND
CLOSE 2

TimeCheck& = GetTime&(NewUser$) ' Obtain the number of minutes since the turn
                                ' of the century to last new user' call.
OPEN GetFile$ FOR INPUT AS 1    ' PCBoard New User file
OPEN PutFile$ FOR BINARY AS 2   ' Receiving file - PDQ Code only
'OPEN PutFile$ FOR APPEND AS 2   ' Quick Basic Code

WHILE NOT EOF(1)                ' Check entire PCBoard New User file
   INPUT #1, NewUser$
   P = INSTR(NewUser$, "* NEW USER *") ' Look for new user
   IF P THEN                           ' If new user found
      UserTime& = GetTime&(NewUser$)   ' Get call time in minutes
      IF UserTime& > TimeCheck& THEN   ' If new caller
         DO                            ' Skip errors in logging
            INPUT #1, S$               ' on under the wrong name
         LOOP WHILE INSTR(S$, "Attempted")
         IF INSTR(S$, "Refused") THEN  ' check for refusals to provide info
            MID$(NewUser$, P) = "* REFUSED  *" ' Warn Sysop
         END IF
         SEEK 2, LOF(2) + 1          ' Use in PDQ program - remove for QBasic
         PRINT #2, NewUser$          ' Put new caller info in receiving file
      END IF
   END IF
WEND
CLOSE

FUNCTION GetTime& (S$)

S& = 1440                      ' Minutes in each day
D = Date2Num(LEFT$(S$, 8))     ' Days since turn of century
T& = Time2Num&(MID$(S$, 11, 5) + ":00") \ 60  'Minutes since mid-night

GetTime& = D * S& + T&

'Basic Code to replace the above (untested)
'S& = 1440
'D = VAL(S$) - 1
'P = VAL(MID$(S$, 4, 2)) - 1
'Y = VAL(MID$(S$, 7, 2))
'H = VAL(MID$(S$, 11, 2))
'M = VAL(MID$(S$, 14, 2))

'GetTime& = D * S& + P * 31 * S& + Y * 366 * S& + H * 60 + M

END FUNCTION

